CSFML - C binding of the Simple and Fast Multimedia Library

CSFML 3.0.0
Loading...
Searching...
No Matches
Enumerations | Functions
WindowBase.h File Reference
`#include <CSFML/Window/Export.h>`
`#include <CSFML/System/Time.h>`
`#include <CSFML/System/Vector2.h>`
`#include <CSFML/Window/Event.h>`
`#include <CSFML/Window/Types.h>`
`#include <CSFML/Window/VideoMode.h>`
`#include <CSFML/Window/Vulkan.h>`
`#include <CSFML/Window/WindowHandle.h>`

Go to the source code of this file.

## Enumerations
enum | sfWindowStyle { sfNone = 0 , sfTitlebar = 1 << 0 , sfResize = 1 << 1 , sfClose = 1 << 2 , sfDefaultStyle = sfTitlebar | sfResize | sfClose }
| Enumeration of window creation styles. More...
enum | sfWindowState { sfWindowed , sfFullscreen }
| Enumeration of the window states. More...

## Functions
sfWindowBase * | sfWindowBase_create (sfVideoMode mode, const char *title, uint32_t style, sfWindowState state)
| Construct a new window.
sfWindowBase * | sfWindowBase_createUnicode (sfVideoMode mode, const sfChar32 *title, uint32_t style, sfWindowState state)
| Construct a new window (with a UTF-32 title).
sfWindowBase * | sfWindowBase_createFromHandle (sfWindowHandle handle)
| Construct a window from an existing control.
void | sfWindowBase_destroy (const sfWindowBase *windowBase)
| Destroy a window.
void | sfWindowBase_close (sfWindowBase *windowBase)
| Close a window and destroy all the attached resources.
bool | sfWindowBase_isOpen (const sfWindowBase *windowBase)
| Tell whether or not a window is opened.
bool | sfWindowBase_pollEvent (sfWindowBase *windowBase, sfEvent *event)
| Pop the event on top of event queue, if any, and return it.
bool | sfWindowBase_waitEvent (sfWindowBase *windowBase, sfTime timeout, sfEvent *event)
| Wait for an event and return it.
sfVector2i | sfWindowBase_getPosition (const sfWindowBase *windowBase)
| Get the position of a window.
void | sfWindowBase_setPosition (sfWindowBase *windowBase, sfVector2i position)
| Change the position of a window on screen.
sfVector2u | sfWindowBase_getSize (const sfWindowBase *windowBase)
| Get the size of the rendering region of a window.
void | sfWindowBase_setSize (sfWindowBase *windowBase, sfVector2u size)
| Change the size of the rendering region of a window.
void | sfWindowBase_setMinimumSize (sfWindowBase *windowBase, const sfVector2u *minimumSize)
| Set the minimum window rendering region size.
void | sfWindowBase_setMaximumSize (sfWindowBase *windowBase, const sfVector2u *maximumSize)
| Set the maximum window rendering region size.
void | sfWindowBase_setTitle (sfWindowBase *windowBase, const char *title)
| Change the title of a window.
void | sfWindowBase_setUnicodeTitle (sfWindowBase *windowBase, const sfChar32 *title)
| Change the title of a window (with a UTF-32 string).
void | sfWindowBase_setIcon (sfWindowBase *windowBase, sfVector2u size, const uint8_t *pixels)
| Change a window's icon.
void | sfWindowBase_setVisible (sfWindowBase *windowBase, bool visible)
| Show or hide a window.
void | sfWindowBase_setMouseCursorVisible (sfWindowBase *windowBase, bool visible)
| Show or hide the mouse cursor.
void | sfWindowBase_setMouseCursorGrabbed (sfWindowBase *windowBase, bool grabbed)
| Grab or release the mouse cursor.
void | sfWindowBase_setMouseCursor (sfWindowBase *windowBase, const sfCursor *cursor)
| Set the displayed cursor to a native system cursor.
void | sfWindowBase_setKeyRepeatEnabled (sfWindowBase *windowBase, bool enabled)
| Enable or disable automatic key-repeat.
void | sfWindowBase_setJoystickThreshold (sfWindowBase *windowBase, float threshold)
| Change the joystick threshold.
void | sfWindowBase_requestFocus (sfWindowBase *windowBase)
| Request the current window to be made the active foreground window.
bool | sfWindowBase_hasFocus (const sfWindowBase *windowBase)
| Check whether the window has the input focus.
sfWindowHandle | sfWindowBase_getNativeHandle (const sfWindowBase *windowBase)
| Get the OS-specific handle of the window.
bool | sfWindowBase_createVulkanSurface (sfWindowBase *windowBase, const VkInstance *instance, VkSurfaceKHR *surface, const VkAllocationCallbacks *allocator)
| Create a Vulkan rendering surface.

## Enumeration Type Documentation

## ◆ sfWindowState

enum sfWindowState

Enumeration of the window states.

Enumerator
sfWindowed | Floating window.
sfFullscreen | Fullscreen window.

Definition at line 60 of file WindowBase.h.

## ◆ sfWindowStyle

enum sfWindowStyle

Enumeration of window creation styles.

Enumerator
sfNone | No border / title bar (this flag and all others are mutually exclusive).
sfTitlebar | Title bar + fixed border.
sfResize | Titlebar + resizable border + maximize button.
sfClose | Titlebar + close button.
sfDefaultStyle | Default window style.

Definition at line 45 of file WindowBase.h.

## Function Documentation

## ◆ sfWindowBase_close()

void sfWindowBase_close | ( | sfWindowBase * | windowBase | ) |

Close a window and destroy all the attached resources.

After calling this function, the sfWindow object remains valid, you must call sfWindowBase_destroy to actually delete it. All other functions such as sfWindowBase_pollEvent or sfWindowBase_display will still work (i.e. you don't have to test sfWindowBase_isOpen every time), and will have no effect on closed windows.

Parameters

  windowBase | Window object

## ◆ sfWindowBase_create()

sfWindowBase * sfWindowBase_create | ( | sfVideoMode | mode,
|  | const char * | title,
|  | uint32_t | style,
|  | sfWindowState | state )

Construct a new window.

This function creates the window with the size and pixel depth defined in mode. An optional style can be passed to customize the look and behaviour of the window (borders, title bar, resizable, closable, ...). If style contains sfFullscreen, then mode must be a valid video mode.

Parameters

  mode | Video mode to use (defines the width, height and depth of the rendering area of the windowBase)
  title | Title of the window
  style | Window style
  state | Window state

Returns
  A new sfWindow object

## ◆ sfWindowBase_createFromHandle()

sfWindowBase * sfWindowBase_createFromHandle | ( | sfWindowHandle | handle | ) |

Construct a window from an existing control.

Parameters

  handle | Platform-specific handle of the control

Returns
  A new sfWindow object

## ◆ sfWindowBase_createUnicode()

sfWindowBase * sfWindowBase_createUnicode | ( | sfVideoMode | mode,
|  | const sfChar32 * | title,
|  | uint32_t | style,
|  | sfWindowState | state )

Construct a new window (with a UTF-32 title).

This function creates the window with the size and pixel depth defined in mode. An optional style can be passed to customize the look and behaviour of the window (borders, title bar, resizable, closable, ...). If style contains sfFullscreen, then mode must be a valid video mode.

Parameters

  mode | Video mode to use (defines the width, height and depth of the rendering area of the windowBase)
  title | Title of the window (UTF-32)
  style | Window style
  state | Window state

Returns
  A new sfWindow object

## ◆ sfWindowBase_createVulkanSurface()

bool sfWindowBase_createVulkanSurface | ( | sfWindowBase * | windowBase,
|  | const VkInstance * | instance,
|  | VkSurfaceKHR * | surface,
|  | const VkAllocationCallbacks * | allocator )

Create a Vulkan rendering surface.

Parameters

  windowBase | Window object
  instance | Vulkan instance
  surface | Created surface
  allocator | Allocator to use

Returns
  True if surface creation was successful, false otherwise

## ◆ sfWindowBase_destroy()

void sfWindowBase_destroy | ( | const sfWindowBase * | windowBase | ) |

Destroy a window.

Parameters

  windowBase | Window to destroy

## ◆ sfWindowBase_getNativeHandle()

sfWindowHandle sfWindowBase_getNativeHandle | ( | const sfWindowBase * | windowBase | ) |

Get the OS-specific handle of the window.

The type of the returned handle is sfWindowHandle, which is a typedef to the handle type defined by the OS. You shouldn't need to use this function, unless you have very specific stuff to implement that SFML doesn't support, or implement a temporary workaround until a bug is fixed.

Parameters

  windowBase | Window object

Returns
  System handle of the window

## ◆ sfWindowBase_getPosition()

sfVector2i sfWindowBase_getPosition | ( | const sfWindowBase * | windowBase | ) |

Get the position of a window.

Parameters

  windowBase | Window object

Returns
  Position in pixels

## ◆ sfWindowBase_getSize()

sfVector2u sfWindowBase_getSize | ( | const sfWindowBase * | windowBase | ) |

Get the size of the rendering region of a window.

The size doesn't include the titlebar and borders of the window.

Parameters

  windowBase | Window object

Returns
  Size in pixels

## ◆ sfWindowBase_hasFocus()

bool sfWindowBase_hasFocus | ( | const sfWindowBase * | windowBase | ) |

Check whether the window has the input focus.

At any given time, only one window may have the input focus to receive input events such as keystrokes or most mouse events.

Returns
  True if window has focus, false otherwise

## ◆ sfWindowBase_isOpen()

bool sfWindowBase_isOpen | ( | const sfWindowBase * | windowBase | ) |

Tell whether or not a window is opened.

This function returns whether or not the window exists. Note that a hidden window (sfWindowBase_setVisible(false)) will return true.

Parameters

  windowBase | Window object

Returns
  true if the window is opened, false if it has been closed

## ◆ sfWindowBase_pollEvent()

bool sfWindowBase_pollEvent | ( | sfWindowBase * | windowBase,
|  | sfEvent * | event )

Pop the event on top of event queue, if any, and return it.

This function is not blocking: if there's no pending event then it will return false and leave event unmodified. Note that more than one event may be present in the event queue, thus you should always call this function in a loop to make sure that you process every pending event.

Parameters

  windowBase | Window object
  event | Event to fill, if any

Returns
  true if an event was returned, or false if the event queue was empty

## ◆ sfWindowBase_requestFocus()

void sfWindowBase_requestFocus | ( | sfWindowBase * | windowBase | ) |

Request the current window to be made the active foreground window.

At any given time, only one window may have the input focus to receive input events such as keystrokes or mouse events. If a window requests focus, it only hints to the operating system, that it would like to be focused. The operating system is free to deny the request.

## ◆ sfWindowBase_setIcon()

void sfWindowBase_setIcon | ( | sfWindowBase * | windowBase,
|  | sfVector2u | size,
|  | const uint8_t * | pixels )

Change a window's icon.

pixels must be an array of width x height pixels in 32-bits RGBA format.

Parameters

  windowBase | Window object
  size | Icon's size, in pixels
  pixels | Pointer to the array of pixels in memory

## ◆ sfWindowBase_setJoystickThreshold()

void sfWindowBase_setJoystickThreshold | ( | sfWindowBase * | windowBase,
|  | float | threshold )

Change the joystick threshold.

The joystick threshold is the value below which no JoystickMoved event will be generated.

Parameters

  windowBase | Window object
  threshold | New threshold, in the range [0, 100]

## ◆ sfWindowBase_setKeyRepeatEnabled()

void sfWindowBase_setKeyRepeatEnabled | ( | sfWindowBase * | windowBase,
|  | bool | enabled )

Enable or disable automatic key-repeat.

If key repeat is enabled, you will receive repeated KeyPress events while keeping a key pressed. If it is disabled, you will only get a single event when the key is pressed.

Key repeat is enabled by default.

Parameters

  windowBase | Window object
  enabled | true to enable, false to disable

## ◆ sfWindowBase_setMaximumSize()

void sfWindowBase_setMaximumSize | ( | sfWindowBase * | windowBase,
|  | const sfVector2u * | maximumSize )

Set the maximum window rendering region size.

Pass a NULL vector to unset the maximum size

Parameters

  windowBase | Window object
  maximumSize | New maximum size, in pixels

## ◆ sfWindowBase_setMinimumSize()

void sfWindowBase_setMinimumSize | ( | sfWindowBase * | windowBase,
|  | const sfVector2u * | minimumSize )

Set the minimum window rendering region size.

Pass a NULL vector to unset the minimum size

Parameters

  windowBase | Window object
  minimumSize | New minimum size, in pixels

## ◆ sfWindowBase_setMouseCursor()

void sfWindowBase_setMouseCursor | ( | sfWindowBase * | windowBase,
|  | const sfCursor * | cursor )

Set the displayed cursor to a native system cursor.

Upon window creation, the arrow cursor is used by default.

Warning
  The cursor must not be destroyed while in use by the window.
  Features related to Cursor are not supported on iOS and Android.

Parameters

  windowBase | Window object
  cursor | Native system cursor type to display

See also
  sfCursor_createFromSystem
  sfCursor_createFromPixels

## ◆ sfWindowBase_setMouseCursorGrabbed()

void sfWindowBase_setMouseCursorGrabbed | ( | sfWindowBase * | windowBase,
|  | bool | grabbed )

Grab or release the mouse cursor.

If set, grabs the mouse cursor inside this window's client area so it may no longer be moved outside its bounds. Note that grabbing is only active while the window has focus and calling this function for fullscreen windows won't have any effect (fullscreen windows always grab the cursor).

Parameters

  windowBase | Window object
  grabbed | true to enable, false to disable

## ◆ sfWindowBase_setMouseCursorVisible()

void sfWindowBase_setMouseCursorVisible | ( | sfWindowBase * | windowBase,
|  | bool | visible )

Show or hide the mouse cursor.

Parameters

  windowBase | Window object
  visible | true to show, false to hide

## ◆ sfWindowBase_setPosition()

void sfWindowBase_setPosition | ( | sfWindowBase * | windowBase,
|  | sfVector2i | position )

Change the position of a window on screen.

This function only works for top-level windows (i.e. it will be ignored for windows created from the handle of a child window/control).

Parameters

  windowBase | Window object
  position | New position of the windowBase, in pixels

## ◆ sfWindowBase_setSize()

void sfWindowBase_setSize | ( | sfWindowBase * | windowBase,
|  | sfVector2u | size )

Change the size of the rendering region of a window.

Parameters

  windowBase | Window object
  size | New size, in pixels

## ◆ sfWindowBase_setTitle()

void sfWindowBase_setTitle | ( | sfWindowBase * | windowBase,
|  | const char * | title )

Change the title of a window.

Parameters

  windowBase | Window object
  title | New title

## ◆ sfWindowBase_setUnicodeTitle()

void sfWindowBase_setUnicodeTitle | ( | sfWindowBase * | windowBase,
|  | const sfChar32 * | title )

Change the title of a window (with a UTF-32 string).

Parameters

  windowBase | Window object
  title | New title

## ◆ sfWindowBase_setVisible()

void sfWindowBase_setVisible | ( | sfWindowBase * | windowBase,
|  | bool | visible )

Show or hide a window.

Parameters

  windowBase | Window object
  visible | true to show the windowBase, false to hide it

## ◆ sfWindowBase_waitEvent()

bool sfWindowBase_waitEvent | ( | sfWindowBase * | windowBase,
|  | sfTime | timeout,
|  | sfEvent * | event )

Wait for an event and return it.

This function is blocking: if there's no pending event then it will wait until an event is received or until the provided timeout elapses. Only if an error or a timeout occurs the function returns false. This function is typically used when you have a thread that is dedicated to events handling: you want to make this thread sleep as long as no new event is received.

while (sfWindowBase_waitEvent(windowBase, timeout, &event))
{
// process event...
}
sfWindowBase_waitEvent
bool sfWindowBase_waitEvent(sfWindowBase *windowBase, sfTime timeout, sfEvent *event)
Wait for an event and return it.

Parameters

  windowBase | Window base object
  timeout | Maximum time to wait (sfTime_Zero for infinite)
  event | Event to fill, if any

Returns
  true if an event was returned, false if event queue was empty or function timed out